const storage = localStorage ?? {};
if (!storage.jStorage) {
    storage.jStorage = '{}';
}

const CLEAR = () => {
    storage.jStorage = '{}';
};
const SET_STORAGE = (key, value) => {
    const data = JSON.parse(storage.jStorage);
    data[key] = value;
    storage.jStorage = JSON.stringify(data);
};

export default {
    namespaced: true,
    state: {
        hideSidebar: false,
        dialplanTab: 0,
        trunkTab: 0,
        devicesTab: 0,
        usersTab: 0,
    },
    getters: {
        isHideSidebar: ({hideSidebar}) => hideSidebar,
        selectedDialplansTab: ({dialplanTab}) => dialplanTab ?? 0,
        selectedTrunksTab: ({trunkTab}) => trunkTab ?? 0,
        selectedDevicesTab: ({devicesTab}) => devicesTab ?? 0,
        selectedUsersTab: ({usersTab}) => usersTab ?? 0,
        selectedHotelsTab: ({hotelsTab}) => hotelsTab ?? 0
    },
    actions: {
        init({commit}) {
            commit('init', JSON.parse(storage.jStorage));
        },
        toggleSidebar({commit, getters}) {
            commit('set', {key: 'hideSidebar', value: !getters.isHideSidebar});
        },
        setTab({commit}, {key, value}) {
            commit('set', {key, value});
        },
        logout() {
            CLEAR();
        }
    },
    mutations: {
        init(state, data) {
            console.log('_____INIT____', data);
            Object.assign(state, data);
        },
        set(state, {key, value}) {
            state[key] = value;
            SET_STORAGE(key, value);
        }
    }
};
